<?php
ini_set('display_errors', 'On');

$db = new PDO('mysql:dbname=midgard;host=localhost', 'root', '', array(PDO::ATTR_ERRMODE => PDO::ERRMODE_EXCEPTION));

$stmt = $db->prepare('SELECT DISTINCT product FROM org_maemo_productsstats_stats');
$stmt->execute();
$products = $stmt->fetchAll(PDO::FETCH_COLUMN);

$ins_q = $db->prepare('INSERT INTO ratings (product, rdate, rating) VALUES (:product, :date, :rating)');
$prod_date_q = $db->prepare('SELECT metadata_published FROM org_openpsa_products_product WHERE id = :id');

foreach ($products as $product) {
    $start = new DateTime('2009-07-30');
    $start->modify('+13 days');

    $ins_q->execute(array(':product' => $product, ':date' => $start->format('Y-m-d'), ':rating' => 100));
    $start->modify('+1 day');

    $stmt = $db->prepare('SELECT DATE(metadata_created) FROM org_maemo_productsstats_stats WHERE product = :product AND DATE(metadata_created) >= :date');
    $stmt->execute(array(':product' => $product, ':date' => $start->format('Y-m-d')));

    $dates = $stmt->fetchAll(PDO::FETCH_COLUMN);

    echo $product.': ';
    foreach ($dates as $date) {
        $this_week_end = new DateTime($date);

        $prev_week_end = clone $this_week_end;
        $prev_week_end->modify('-7 days');

        $prev_week_start = clone $prev_week_end;
        $prev_week_start->modify('-6 days');

        $prev_week_condition = 'DATE(metadata_created) >= "'.$prev_week_start->format('Y-m-d').'" AND DATE(metadata_created) <= "'.$prev_week_end->format('Y-m-d').'"';
        $this_week_condition = 'DATE(metadata_created) > "'.$prev_week_end->format('Y-m-d').'" AND DATE(metadata_created) <= "'.$this_week_end->format('Y-m-d').'"';

        // getting elements
        $q = $db->prepare('SELECT AVG(downloadsDelta), AVG(comments), AVG(ratings) FROM org_maemo_productsstats_stats WHERE product = :product AND '.$prev_week_condition);
        $q->execute(array(':product' => $product));
        list($avg_d_last_week, $avg_c_last_week, $avg_v_last_week) = $q->fetch(PDO::FETCH_NUM);

        $q = $db->prepare('SELECT AVG(downloadsDelta), AVG(comments), AVG(ratings) FROM org_maemo_productsstats_stats WHERE product = :product AND '.$this_week_condition);
        $q->execute(array(':product' => $product));
        list($avg_d_this_week, $avg_c_this_week, $avg_v_this_week) = $q->fetch(PDO::FETCH_NUM);

        $yesterday = clone $this_week_end;
        $yesterday->modify('-1 day');
        $q = $db->prepare('SELECT rating FROM ratings WHERE product = :product AND rdate = :date');
        $q->execute(array(':product' => $product, ':date' => $yesterday->format('Y-m-d')));
        $yesterday = $q->fetchColumn();

        // 1. base variant
        $rating = calculate_rating($yesterday, $avg_d_this_week, $avg_d_last_week, $avg_c_this_week, $avg_c_last_week, $avg_v_this_week, $avg_v_last_week);
        // [/1]

        // 2. variant niels breet
        // $rating = calculate_rating_niels($yesterday, $avg_d_this_week, $avg_d_last_week, $avg_c_this_week, $avg_c_last_week, $avg_v_this_week, $avg_v_last_week);
        // [/1]

        // 3. variant by andrew flegg
        // $_today_time = new DateTime($date.' 23:59:59');
        // $today_time = $_today_time->format('U');
        // 
        // $prod_date_q->execute(array(':id' => $product));
        // $last_update_time = strtotime($prod_date_q->fetchColumn());
        // 
        // $rating = calculate_rating_andrew($yesterday, $avg_d_this_week, $avg_d_last_week, $avg_c_this_week, $avg_c_last_week, $avg_v_this_week, $avg_v_last_week, $today_time, $last_update_time);
        // [/2]

        $ins_q->execute(array(':product' => $product, ':date' => $date, ':rating' => $rating));

        echo '.';
    }
    echo "\n";
}


function calculate_rating($yesterday, $avg_d_week, $avg_d_last_week, $avg_c_week, $avg_c_last_week, $avg_v_week, $avg_v_last_week)
{
    $rating = ($yesterday * 0.999)
                + 0.1 * ($avg_d_week - $avg_d_last_week)
                + 0.1 * ($avg_c_week - $avg_c_last_week)
                + 0.1 * ($avg_v_week - $avg_v_last_week);

    return $rating;
}

function calculate_rating_andrew($yesterday, $avg_d_week, $avg_d_last_week, $avg_c_week, $avg_c_last_week, $avg_v_week, $avg_v_last_week, $today_time, $last_update_time)
{
    $rating = ($yesterday * 0.99)
                + 0.1 * pow(($avg_d_week - $avg_d_last_week), 1.5)
                + 0.1 * pow(($avg_c_week - $avg_c_last_week), 1.4)
                + 0.1 * pow(($avg_v_week - $avg_v_last_week), 1.6)
                + 2   * sqrt(($today_time - $last_update_time) / 24*3600);

    return $rating;
}

function calculate_rating_niels($yesterday, $avg_d_week, $avg_d_last_week, $avg_c_week, $avg_c_last_week, $avg_v_week, $avg_v_last_week)
{
    $rating = ($yesterday * 0.999);
    if ($avg_d_week + $avg_d_last_week > 0)
        $rating += (($avg_d_week - $avg_d_last_week) / ($avg_d_week + $avg_d_last_week));
    if ($avg_c_week + $avg_c_last_week > 0)
        $rating += (($avg_c_week - $avg_c_last_week) / ($avg_c_week + $avg_c_last_week));
    if ($avg_v_week + $avg_v_last_week > 0)
        $rating += (($avg_v_week - $avg_v_last_week) / ($avg_v_week + $avg_v_last_week));

    return $rating;
}
